package com.bjsxt.server;

import com.bjsxt.servlet.Servlet;
import com.bjsxt.util.IOCloseUtil;

import java.io.IOException;
import java.io.InputStream;
import java.net.ServerSocket;
import java.net.Socket;

public class Server {//服务器，用于启动和停止服务
    private ServerSocket server;
    private boolean isShutDown=false;//默认没有出错
    public static void main(String[] args) {
        Server server=new Server();//创建服务器对象
        server.start();
    }
    public void start(){
        this.start(8888);
    }
    public void start(int port){
        try {
            server=new ServerSocket(port);
            this.receive(); //调用接收请求信息的方法
        } catch (IOException e) {
            isShutDown=true;
        }
    }
    private void receive() {
        try {
            while (!isShutDown){
                //(1)监听
                Socket client=server.accept();
                //创建线程类的对象
                Dispatcher dis=new Dispatcher(client);
                //创建代理类并启动线程
                new Thread(dis).start();
            }
        } catch (IOException e) {
            this.stop();//关闭服务器
        }

    }
    public void stop(){
        isShutDown=true;
        IOCloseUtil.closeAll(server);
    }
}
